function PR.GUI.MainDialog:k_any(key)
    if key == 115 then -- s
        PR.GUI.View = "Sector"
        PR.GUI.Refresh()
    elseif key == 102 then -- f
        PR.GUI.View = "Search"
        PR.GUI.Refresh()
    elseif key == 118 then -- u
        PR.GUI.View = "Universe"
        PR.GUI.Refresh()
    elseif key == 99 then -- c
        PR.GUI.View = "Config"
        PR.GUI.Refresh()
    else
        local command = gkinterface.GetCommandForKeyboardBind(key)
        if command == "prospector" or command == "pr" or command == "ore" then
            PR.GUI.Close()
        end
    end
    return iup.IGNORE
end

function PR.GUI.MainDialog:close_cb()
    PR.GUI.Close()
end

function PR.GUI.Btn_Top1:action()
    if PR.GUI.View == "Universe" then
        PR.GUI.View = "Sector"
    elseif PR.GUI.View == "Sector" then
        PR.GUI.View = "Search"
        PR.GUI.DisplayedSector = 0
    elseif PR.GUI.View == "Search" then
        PR.GUI.View = "Config"
    elseif PR.GUI.View == "Config" then
        PR.GUI.View = "Universe"
    end
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Top2:action()
    if PR.GUI.View == "Universe" then
        if PR.Config.UniverseSort == "ByOre" then
            PR.Config.UniverseSort = "BySystem"
        else
            PR.Config.UniverseSort = "ByOre"
        end
    elseif PR.GUI.View == "Search" then
        local function nextOre()
            local orecount = PR.Ore.n
            for i = 1, orecount do
                if PR.Config.Search.Ore == PR.Ore[i].shortname then
                    if i == orecount then i = 1 else i = i + 1 end
                    PR.Config.Search.Ore = PR.Ore[i].shortname
                    return
                end
            end
        end

        nextOre()
    elseif PR.GUI.View == "Sector" then
        if PR.Config.SectorSort == "ById" then
            PR.Config.SectorSort = "ByXPV"
        elseif PR.Config.SectorSort == "ByXPV" then
            PR.Config.SectorSort = "ByMass"
        elseif PR.Config.SectorSort == "ByMass" then
            PR.Config.SectorSort = "ByValue"
        elseif PR.Config.SectorSort == "ByValue" then
            PR.Config.SectorSort = "ByOre"
        else
            PR.Config.SectorSort = "ById"
        end
    elseif PR.GUI.View == "Config" then
        PR.Config.PrintToHUD = not PR.Config.PrintToHUD
    end
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Top3:action()
    if PR.GUI.View == "Search" then
        if PR.Config.Search.Area == "Serco" then
            PR.Config.Search.Area = "Itani"
        elseif PR.Config.Search.Area == "Itani" then
            PR.Config.Search.Area = "UIT"
        elseif PR.Config.Search.Area == "UIT" then
            PR.Config.Search.Area = "Gray"
        else
            PR.Config.Search.Area = "Serco"
        end
        PR.GUI.FetchNextSystem()
    elseif PR.GUI.View == "Config" then
        PR.Config.COLOR = not PR.Config.COLOR
    elseif PR.GUI.View == "Sector" and PR.Config.SectorSort == "ByOre" then
        if PR.GUI.OreSort > 0 then
            PR.GUI.OreSort = (PR.GUI.OreSort < PR.GUI.SectorOres.n) and
                (PR.GUI.OreSort + 1) or 1
            PR.GUI.Btn_Top3.title = PR.GUI.SectorOres[PR.GUI.OreSort].name
        end
    end
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Top4:action()
    if PR.GUI.View == "Search" then
        PR.GUI.FetchNextSystem()
    elseif PR.GUI.View == "Config" then
        PR.Config.VerbosityLevel = (PR.Config.VerbosityLevel <
            #PR.VerbosityLevels) and (PR.Config.VerbosityLevel + 1) or 1
    elseif PR.GUI.View == "Sector" then
        if PR.GUI.DisplayedSector ~= PR.Sector and
            PR.GUI.DisplayedSector ~= NavRoute.GetFinalDestination() then
            NavRoute.SetFinalDestination(PR.GUI.DisplayedSector)
            PR.Print("Navigation destination set to " ..
                ShortLocationStr(PR.GUI.DisplayedSector), true)
            PR.GUI.Btn_Top4.title = "NavRoute set"
            PR.GUI.Btn_Top4.fgcolor = PR.GUI.COLOR.GREEN
        elseif PR.SingleSearchTarget > 0 then
            PR.SingleSearchStop()
        end
    end
    PR.GUI.Refresh()
end

function PR.GUI.Btn_100Minus:action()
    local value = tonumber(PR.GUI.UserInput.value)
    if value then
        value = value - 100
        if value < 1 then value = 1 end
        PR.GUI.UserInput.value = value
    end
end

function PR.GUI.Btn_100Plus:action()
    local value = tonumber(PR.GUI.UserInput.value)
    if value then
        value = value + 100
        if value < 1 then value = 1 end
        PR.GUI.UserInput.value = value
    end
end

function PR.GUI.DisplayPanel:action(text, index, state)
    -- state == 0 is the previous selection, state == 1 the current
    if state == 1 then
        if PR.GUI.View == "Sector" and PR.GUI.DisplayedSector == PR.Sector and
            not PlayerInStation() then
            PR.SingleSearchStart(PR.GUI.ListedItems[index])
            PR.GUI.Btn_Top4.fgcolor = PR.GUI.COLOR.RED
            PR.GUI.Btn_Top4.title = "Stop Search"
        elseif PR.GUI.View == "Search" then
            PR.GUI.View = "Sector"
            PR.GUI.DisplayedSector = PR.GUI.ListedItems[index]
            PR.GUI.Refresh()
        elseif PR.GUI.View == "Config" then
            if text and text:find("=") then
                PR.GUI.UserInput.value = PR.Config[ PR.GUI.EditableValues[index] ]
            else
                PR.GUI.UserInput.value = "select option"
            end
        end
    end
end

function PR.GUI.Btn_Bottom1:action()
    if PR.GUI.View == "Config" then
        if PR.GUI.DisplayPanel.Value then
            local idx = tonumber(PR.GUI.DisplayPanel.Value) or 0
            if idx > 0 then
                local value = tonumber(PR.GUI.UserInput.value)
                if value and value < 1 then value = 1 end
                PR.Config[ PR.GUI.EditableValues[idx] ] = value or
                    PR.Config[ PR.GUI.EditableValues[idx] ]
            end
        end
    end
    PR.SaveConfigNow()
    PR.GUI.Refresh()
end

function PR.GUI.Btn_Bottom2:action()
    PR.GUI.Close()
end

function PR.GUI.Btn_Bottom3:action()
    if PR.GUI.View == "Sector" then
        ShowDialog(PR.GUI.ConfirmationDialog)
    end
end

function PR.GUI.Btn_ConfirmationReset:action()
    PR.ResetSector(PR.GUI.LoadedSector)
    PR.Print("All data for the current sector has been permanently reset", true)
    PR.GUI.Refresh()
    return iup.CLOSE
end

function PR.GUI.Btn_ConfirmationCancel:action()
    return iup.CLOSE
end
