dofile("GUI/iup_layout.lua")
dofile("GUI/iup_callbacks.lua")
dofile("GUI/view_config.lua")
dofile("GUI/view_search.lua")
dofile("GUI/view_sector.lua")
dofile("GUI/view_universe.lua")

function PR.GUI.Refresh()
    for i = 1, PR.GUI.MaxDisplayRows do PR.GUI.DisplayPanel[i] = nil end
    PR.GUI.DisplayPanel[1] = "No data available"
    PR.GUI.MaxDisplayRows = 1
    PR.GUI.ListedItems = {}

    PR.GUI.Btn_Top1.title = PR.GUI.View
    PR.GUI.Btn_Top2.title = ""
    PR.GUI.Btn_Top2.fgcolor = PR.GUI.COLOR.AQUAPERL
    PR.GUI.Btn_Top3.title = ""
    PR.GUI.Btn_Top3.fgcolor = PR.GUI.COLOR.AQUAPERL
    PR.GUI.Btn_Top4.title = ""
    PR.GUI.Btn_Top4.fgcolor = PR.GUI.COLOR.AQUAPERL
    PR.GUI.UserInput.value = ""
    iup.Detach(PR.GUI.EditBox)
    PR.GUI.Btn_Bottom3.title = ""

    if PR.GUI.View == "Sector" then
        PR.GUI.RefreshSectorBox()
        -- for faster checking by PR.TargetScanned to update temps
        PR.GUI.CurrentSectorShowing = PR.GUI.DisplayedSector == PR.LoadedSector
    else
        PR.GUI.CurrentSectorShowing = false
        if PR.GUI.View == "Universe" then
            PR.GUI.RefreshUniverseBox()
        elseif PR.GUI.View == "Search" then
            PR.GUI.RefreshSearchBox()
        elseif PR.GUI.View == "Config" then
            PR.GUI.RefreshConfigBox()
        end
    end
    iup.Refresh(PR.GUI.MainDialog[1][1])
end

function PR.GUI.ShowGUI()
    if PR.PluginReady then
        -- force a pending update
        PR.SaveNow()

        ShowDialog(PR.GUI.MainDialog)
        -- enforce minimum width of 500px
        if tonumber(HUDSize(1)) < 1000 then PR.GUI.MainDialog.size = "500x" end
        PR.GUI.DisplayedSector = 0
        PR.GUI.Refresh()
    else
        PR.Print("Prospector not ready yet, please wait.")
    end
end

function PR.GUI.Close()
    PR.GUI.MainDialog:hide()
    -- free some memory
    for i = 1, PR.GUI.MaxDisplayRows do PR.GUI.DisplayPanel[i] = nil end
    PR.GUI.SectorRoidList = {}
    PR.GUI.SystemData = {}
    PR.GUI.CurrentSectorShowing = false
    return iup.CLOSE
end
