function PR.GUI.RefreshUniverseBox()
    PR.GUI.Btn_Top2.title = PR.Config.UniverseSort
    PR.LoadAllSystemData(PR.GUI.SystemData)
    if PR.Config.UniverseSort == "ByOre" then PR.GUI.ShowUniverseByOre()
    elseif PR.Config.UniverseSort == "BySystem" then PR.GUI.ShowUniverseBySystem()
    end
end

function PR.GUI.ShowUniverseByOre()
    local systemoretable = {}
    for sysid = 1, PR.SystemOwnership.n do
        if PR.GUI.SystemData[sysid] then
            for i = 1, PR.Ore.n do
                if PR.GUI.SystemData[sysid][PR.Ore[i].shortname] then
                    if not systemoretable[PR.Ore[i].shortname] then
                        systemoretable[PR.Ore[i].shortname] = {}
                    end
                    local orecount = PR.GetOreCountInSystem(
                        PR.GUI.SystemData[sysid][PR.Ore[i].shortname])
                    if orecount > 0 then
                        table.insert(systemoretable[PR.Ore[i].shortname],
                            PR.COLOR.FactionColors[ PR.SystemOwnership[sysid] ] ..
                            PR.GUI.SystemData[sysid].systemname ..
                            PR.COLOR.LGRAY .. " (" .. orecount .. ")" ..
                            PR.COLOR.TERMINATOR)
                    end
                end
            end
        end
    end

    local row = 1
    for i = 1, PR.Ore.n do
        PR.GUI.DisplayPanel[row] = "\t" .. PR.Ore[i].color .. PR.Ore[i].name
        if not systemoretable[PR.Ore[i].shortname] then
            systemoretable[PR.Ore[i].shortname] = {}
        end
        table.sort(systemoretable[PR.Ore[i].shortname])
        -- horizontal listing (would need horizontal scroll bar):
        --PR.GUI.DisplayPanel[row] = table.concat(systemoretable[ore.shortname], "\n")
        -- vertical listing:
        for idx = 1, #systemoretable[PR.Ore[i].shortname] do
            row = row + 1
            PR.GUI.DisplayPanel[row] = systemoretable[PR.Ore[i].shortname][idx]
        end
        row = row + 2
    end
    PR.GUI.MaxDisplayRows = row - 2
end

function PR.GUI.ShowUniverseBySystem()
    local row = 1
    for sysid = 1, PR.SystemOwnership.n do
        if PR.GUI.SystemData[sysid] then
            PR.GUI.DisplayPanel[row] = PR.COLOR.FactionColors[ PR.SystemOwnership[sysid] ] ..
                PR.GUI.SystemData[sysid].systemname .. PR.COLOR.TERMINATOR
            row = row + 1
            local orelist = {}
            for i = 1, PR.Ore.n do
                if PR.GUI.SystemData[sysid][PR.Ore[i].shortname] then
                    local orecount = PR.GetOreCountInSystem(
                        PR.GUI.SystemData[sysid][PR.Ore[i].shortname])
                    if orecount > 0 then
                        table.insert(orelist, PR.Ore[i].color ..
                            PR.Ore[i].shortname .. PR.COLOR.LGRAY ..
                            " (" .. orecount .. ")" .. PR.COLOR.TERMINATOR)
                    end
                end
            end
            PR.GUI.DisplayPanel[row] = table.concat(orelist, " - ")
            row = row + 2
        end
    end
    PR.GUI.MaxDisplayRows = row - 2
end
