-- check equipped mining equipment
function PR.CheckEquipment()
    local beamqty = 0
    local totalheat = 0
    PR.BeamAvgHeat = 0
    PR.ScannerEquipped = false
    PR.MiningBeamEquipped = false

    for _, itemid in ipairs(GetShipInventory(GetActiveShipID()).addons) do
        local item_type = GetInventoryItemType(itemid)
        local item_class = InvManager.GetInventoryItemParameter(item_type, "Class") or ""
        if item_class == "Scanner" then
            PR.ScannerEquipped = true
            PR.ScanRange = math.max(PR.ScanRange,
                tonumber(InvManager.GetInventoryItemParameter(item_type, "Range") or 500))
        elseif item_class == "MiningGun" then
            PR.MiningBeamEquipped = true
            beamqty = beamqty + 1
            -- don't know any parameter to query heat, so have to parse the description:
            local heat = tonumber(string.match(GetInventoryItemLongDesc(itemid),
                "Heat: (.-)|"))
            if heat then totalheat = totalheat + heat * 100 end
        end
    end

    -- XXX: this only makes sense if all beams are the same type, otherwise
    -- mining rate would need to be considered, too
    -- also we don't know if all beams are active
    if beamqty > 0 then PR.BeamAvgHeat = totalheat / beamqty end

    -- detect if active ship is one with a built in scanner
    -- (using a static lookup-table - unfortunately no way to query this, either)
    local shipname = GetActiveShipName()
    if PR.ShipsWithMineralScanner[shipname] then
        PR.ScannerEquipped = true
        PR.ScanRange = math.max(PR.ScanRange, PR.ShipsWithMineralScanner[shipname])
    end
end
