-- prints repeating status messages (depending on verbosity level)
-- set @autoscanForce to force autoscan active message
function PR.StatusPrint(autoscanForce)
    PR.SpamTimer:SetTimeout(PR.AutoScanActive and 15000 or 90000, PR.StatusPrint)

    -- don't bother us while in station or without mining/scanning equipment
    if PlayerInStation() or not PR.ScannerEquipped then
        return
    end

    if (PR.AutoScanActive and PR.Config.VerbosityLevel > 1) or
        (PR.Config.VerbosityLevel == 2 and PR.LastSpamSector ~= PR.Sector) or
        PR.Config.VerbosityLevel > 2 then
        -- make sure we're looking at the correct data
        PR.LoadSector(PR.Sector)
        PR.LastSpamSector = PR.Sector
        if PR.Data.Unscanned > 0 then
            PR.Print((PR.Data.MaxId - PR.Data.Unscanned) .. " of " ..
                PR.Data.MaxId .. " expected asteroids scanned in " ..
                ShortLocationStr(PR.Sector))
        else
            PR.SpamHold = PR.SpamHold - 1
            if PR.SpamHold < 1 or PR.LastSpamSector ~= PR.Sector then
                PR.SpamHold = 6
                if PR.Data.MaxId > 0 then
                    PR.Print("All known " .. PR.Data.MaxId ..
                        " asteroids scanned in " .. ShortLocationStr(PR.Sector))
                else
                    PR.Print("No known asteroids in " ..
                        ShortLocationStr(PR.Sector))
                end
            end
        end
    end

    if PR.AutoScanActive and (autoscanForce or PR.Config.VerbosityLevel > 2) then
        PR.Print("Auto-scanning active - scanner range is " ..
            PR.ScanRange .. "m, radar range is " ..
            comma_value(GetMaxRadarDistance()) .. "m")
    end
end
